#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,c,q,sum=0;
    int arr[200010];
    cin>>n>>c>>q;
    string s;
    cin>>s;

    for(int i=0;i<n;i++)
    {
        if(s[i]=='1')
        {
            sum+=1;
        }
    }
    for(int t=0;t<q;t++)
    {
        int l,r;
        cin>>l>>r;
        for(int i=(l-1);i<r;i++)
        {
            if(s[i]=='1')
            {
                s[i]='0';
                sum--;
            }
            else
            {
                s[i]='1';
                sum++;
            }
        }
        arr[t]=sum;
    }
    for(int i=0;i<q;i++)
    {
       cout<<arr[i]<<endl;
    }
    return 0;
}